base64.h File Reference

RFC 1521 base64 encoding/decoding. More...

`#include <stddef.h>`

Go to the source code of this file.

## Functions

int | osmo_base64_encode (unsigned char *dst, size_t dlen, size_t *olen, const unsigned char *src, size_t slen)
| Encode a buffer into base64 format. More...
int | osmo_base64_decode (unsigned char *dst, size_t dlen, size_t *olen, const unsigned char *src, size_t slen)
| Decode a base64-formatted buffer. More...

## Detailed Description

RFC 1521 base64 encoding/decoding.

Copyright (C) 2006-2015, ARM Limited, All Rights Reserved

This file is part of mbed TLS (https://tls.mbed.org)

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

## Function Documentation

## osmo_base64_decode()

int osmo_base64_decode | ( | unsigned char * | dst,
|  | size_t | dlen,
|  | size_t * | olen,
|  | const unsigned char * | src,
|  | size_t | slen
| ) |  |

Decode a base64-formatted buffer.

Parameters

  dst | destination buffer (can be NULL for checking size)
  dlen | size of the destination buffer
  olen | number of bytes written
  src | source buffer
  slen | amount of data to be decoded

Returns
  0 if successful, MBEDTLS_ERR_BASE64_BUFFER_TOO_SMALL, or MBEDTLS_ERR_BASE64_INVALID_CHARACTER if the input data is not correct. *olen is always updated to reflect the amount of data that has (or would have) been written.

Note
  Call this function with *dst = NULL or dlen = 0 to obtain the required buffer size in *olen

References base64_dec_map, and n.

## osmo_base64_encode()

int osmo_base64_encode | ( | unsigned char * | dst,
|  | size_t | dlen,
|  | size_t * | olen,
|  | const unsigned char * | src,
|  | size_t | slen
| ) |  |

Encode a buffer into base64 format.

Parameters

  dst | destination buffer
  dlen | size of the destination buffer
  olen | number of bytes written
  src | source buffer
  slen | amount of data to be encoded

Returns
  0 if successful, or MBEDTLS_ERR_BASE64_BUFFER_TOO_SMALL. *olen is always updated to reflect the amount of data that has (or would have) been written.

Note
  Call this function with dlen = 0 to obtain the required buffer size in *olen

References base64_enc_map, and n.